/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package GUI;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import java.io.*;
import java.util.*;

import org.jdom.*;
import org.jdom.input.*;

/**
 *
 * @author Myshinoo
 */
public class XMLtree extends JTree{

  MainWindow mainWin;
  
  public XMLtree (DefaultMutableTreeNode root, MainWindow win){
    //vytvorim korenovy uzol
		this.setModel(new DefaultTreeModel(root));
    //Zaregistrovanie tool tips.
    ToolTipManager.sharedInstance().registerComponent(this);
    this.mainWin=win;

    this.addMouseListener(ml);
  }
  
  MouseListener ml = new MouseAdapter(){
    public void mousePressed(MouseEvent e){
      int selRow = XMLtree.this.getRowForLocation(e.getX(), e.getY());
      javax.swing.tree.TreePath selPath = XMLtree.this.getPathForLocation(e.getX(), e.getY());
      if(selRow != -1){
        if(e.getButton() == 3){
          //test ci je vobec nejaky dokument otvoreny
          if(mainWin.parser != null){
            XMLtree.this.setSelectionRow(selRow); 
            Object []node = selPath.getPath();
            
            Element element = mainWin.parser.getElementFromTree(null, node, 0);
            if(element!=null)
              System.out.println("element:"+element.getName());
            else
              System.out.println("CHYBA");
            
            
            mainWin.showPopUp(e.getComponent(), e.getX(), e.getY());
            
          //for(int i=0;i<node.length;i++)
           // System.out.println("zoznam:"+node[i].toString());
          }  
        }
      }
    }
  };

  /**
   * 
   * @param document
   */
  public void createTree(Document document) {

    Element root = document.getRootElement();   
    //nazov korenoveho uzlu
    DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(root.getName());
    
    //vytvorenie uzlov
    createNode(root, rootNode);
    //vytvorenie modelu stromu
    this.setModel(new DefaultTreeModel(rootNode)); 
    //nastavenie pravidiel pre vykreslovanie, vstupny parameter korenovy element
    this.setCellRenderer(new MyRenderer(root));
    
    //vytvorenie korenoveho elementu na canvas
    ElementPanel newElement = new ElementPanel(mainWin);
    newElement.createElementComponent(root,null);
    mainWin.drawPanel.addNewElement(newElement);
  }
  
  /**
   * 
   * @param root 
   * @param rootNode 
   */
  public void createNode(Element root, DefaultMutableTreeNode rootNode){
    java.util.List list = root.getChildren();
    for(int i=0; i<list.size();i++){
      Element child =(Element)list.get(i);
      DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(child.getName());
      rootNode.add(childNode);
      
      //spracovanie atributov
      java.util.List attrList = child.getAttributes();
      for(int x=0;x<attrList.size();x++){
        Attribute childAttr = (Attribute)attrList.get(x);
        DefaultMutableTreeNode childAttrNode = new DefaultMutableTreeNode(childAttr.getName());
        childNode.add(childAttrNode);
      }
      //spracovanie vnorenych uzlov
      java.util.List childList = child.getChildren();
      //vytvorenie uzlov stromu rekurziou
      if(childList.size()!=0)
        createNode(child,childNode);
    } 
  }

  /**
  *
  * @author Myshinoo
  */
  private class MyRenderer extends javax.swing.tree.DefaultTreeCellRenderer{
    
    Element root;
    public MyRenderer(Element root){
      this.root=root;
    }
    
    /**
	   * Metóda pre nastavenie vlastností vytváraného stromu 
	   */
    public Component getTreeCellRendererComponent(
      JTree tree,
      Object value,
      boolean sel,
      boolean expanded,
      boolean leaf,
      int row,
      boolean hasFocus) {

      super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
      
      //vytvorenie troch typov ikon      
      Icon attrIcon = new ImageIcon(getClass().getResource("/images/attrIcon.gif"));
      Icon parentIcon = new ImageIcon(getClass().getResource("/images/parent.gif"));
      Icon childIcon = new ImageIcon(getClass().getResource("/images/child.gif"));
        
      if(leaf){
        if(isAttribute(root, value)){
          setIcon(attrIcon);
          setToolTipText("Attribute");
        }
        else{
          setIcon(childIcon);
          setToolTipText("Element without attributes and child elements");
        }
      }
      else{
        setIcon(parentIcon);
        setToolTipText("Element with attributes or child elements");
      }
      return this;
    }
  }
    
  /**
   * Funkcia testuje ci je zadany uzol attributom.
   * @param root 
   * @param value
   */
  public boolean isAttribute(Element root, Object value){
    DefaultMutableTreeNode nodeItem = (DefaultMutableTreeNode)value;
    //vyhlada element 
    Element test = root.getChild(nodeItem.toString());
    //ak nenajde, uzol je atribut a vrati false
    if(test == null)
      return true;
    else
      return false;
  }
}  
