/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package utilityXML;
import GUI.*;

import java.io.*;
import java.util.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.jdom.*;
import org.jdom.input.*;


/**
 *
 * @author Myshinoo
 */
public class XMLreader{

  //prave otvoreny dokument
  public org.jdom.Document openDocument = null;
  //stavova premenna pre zmeny na dokumente
  private boolean documentChanged=false;
  //prave otvoreny dokument
  public File openFile = null;
  
  /**
   * @param args the command line arguments
   */
  public org.jdom.Document openXMLdoc(File file){
    //Instantiate a DocumentBuilderFactory.
    try{
      this.openFile = file;
      DocumentBuilderFactory dFactory = DocumentBuilderFactory.newInstance();
      // And setNamespaceAware, which is required when parsing xsl files
      dFactory.setNamespaceAware(true);
      //Use the DocumentBuilderFactory to create a DocumentBuilder.
      DocumentBuilder dBuilder = dFactory.newDocumentBuilder();
      //Use the DocumentBuilder to parse the XML input.
      org.w3c.dom.Document xmlDoc = dBuilder.parse(file);
     
      DOMBuilder bld = new DOMBuilder();
      org.jdom.Document document = bld.build(xmlDoc);
      
      this.openDocument=document;
      
      return document;
    }
    catch(Exception e){
      e.printStackTrace();
      return null;
    }
  }
  
  /**
   * @param args the command line arguments
   */
  public void saveXMLdoc(org.jdom.Document document, File file){ 
    if(document != null && file != null){
      try{
        org.jdom.output.XMLOutputter outputter = new org.jdom.output.XMLOutputter();
        FileWriter writer = new FileWriter(file);
        outputter.output(document,writer);
        writer.close();
      }
      catch(Exception e){
        e.printStackTrace();
      }
    }  
  }
  
  /**
   * @param args the command line arguments
   */
  public boolean isDocumentChanged(){
    if(this.documentChanged)
      return true;
    else
      return false;
  }
  
  /**
   * @param args the command line arguments
   */
  public void setDocumentChanged(boolean value){
    this.documentChanged=value;
  }

  
  /**
   * Funkcia vracia posledný element zo zoznamu, ak je posledným elementom atribút
   * vracia vlastníka atribútu
   * @param args the command line arguments
   */
  public org.jdom.Element getElementFromTree(org.jdom.Element element, Object[] node, int level){
   
    //pri starte funkcie nepozname korenovy element, vytvori sa
    if(element == null)
      element = this.openDocument.getRootElement();    
    //kontrola na level zanorenia, zanorujem len podla udajov v poli elementov
    if(node.length == (level+1)){
      //dalsie zanorenie nie je potrebne, nasiel som hladany element
      return element;
    }  
    else{
      //hladanie elementu pokracuje, zvysime level hladania(hlbku)
      level++;      
      java.util.List list = element.getChildren(node[level].toString());

      //ak zoznam podla udajov nevratil ziadnych potomkov
      //skontrolujem, ci nahodou nebol oznaceny atribut, ak nebol, som v zlom podstrome a vraciam null
      //inak vratim element, ktoremu patri atribut, hladanie som ukoncil
      if(list.size() == 0){
        if(element.getAttribute(node[level].toString()) == null)
          return null;
        else
          return element;    
      }
      
      for(int i=0; i<list.size(); i++){
        //rekurzivne vyhladavam v mojich podstromoch element
        
        org.jdom.Element child = getElementFromTree((org.jdom.Element)list.get(i), node, level);
        //ak niektory z podstromov nasiel moje element, koncim hladanie
        if(child == null)
          continue; 
        else{
          //ukoncim vyhladavanie
          element = child;
          return element;
        }  
      }
      //v pripade akejkolvek nezhody vratime null aby vyhladavanie pokracovalo
      return null;
    }

  }
  
  
  
}
